# Extract

### Static Data

It is possible to create static datasets by hardcoding data into the code and returning a LazyFrame

```python
import polars as pl

def transform():    
    return pl.LazyFrame({
        "country_name": ["Switzerland", "Germany", "France", "Italy", "Spain"],
        "iso_code": ["CH", "DE", "FR", "IT", "ES"],
        "population": [8600000, 83000000, 67000000, 60000000, 47000000]
    })
```

Or by creating a CSV file in the repository and loading it via `pl.scan_csv("./static.csv")`

### External Sources

DataSpace enables the extraction of data from various sources, including databases, file shares, web crawling, and external APIs, either through ready-made connectors or by writing custom code that connects to a custom API.

{% columns %}
{% column %}
{% content-ref url="/pages/f85aeff091f4e5a655233f2952b91e6556015f7b" %}
[Google Drive](/platform/transformation/extract/google-drive.md)
{% endcontent-ref %}
{% endcolumn %}

{% column %}
{% content-ref url="/pages/aba144dcd54197fa9aa0b24643ffd9e146a94113" %}
[Postgres](/platform/transformation/extract/postgres.md)
{% endcontent-ref %}
{% endcolumn %}
{% endcolumns %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.dataspace.ch/platform/transformation/extract.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
